Invoking shell script from shell script


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Invoking shell script from shell script
# 1  
Old 12-03-2001
Invoking shell script from shell script

I am trying to invoke another shell script from a shell script and I am not sure of how to check the return code of the called script. Please help.


Thanks
Roshan
# 2  
Old 12-03-2001
if your just looking for success just call the other script in an if statemend:

if $HOME/scripts/imi_reserve
then :
else DoErrorMessage "Call to imi_reserve failed in daily_deployment_ext, retcd = $?"
DoAbort
fi
# 3  
Old 12-03-2001
Question

I am not just checking for if the script ran or not. If I need to check the return code from the invoked program. Is this how I would do it ?


Have an exit code code specified for each action in the called program and then when I call it and check $? for the error code ?

Please correct me if I am wrong.

Thanks
Roshan
# 4  
Old 12-04-2001
That looks about right to me...
To paraphrase:

Code:
(...)
/path/to/other/script
case $? in
0) Do something ;;
*) Do something else ;;
esac
(...)

or:
Code:
(...)
/path/to/other/script
if [ "$?" -ne "0" ]; then
freak out here
fi
(...)

There are several different ways of doing what you need.

Hope that helps.
# 5  
Old 12-05-2001
Network read

Hi,

I tried code like this


echo " Enter user name :\c"
read resp

if (test $? -ne 0)
then
exit
fi

The above condition is not working if there is
a terminal hungup happens.
when I run the shell script it echoes
Enter user name :

At that time, when the user is not able to enter due to some
reason and the terminal is hungup. Still the process is running
without exiting.

How can we catch this kind of error ? Do we need to use
any signals ?

Thanks,
kk
# 6  
Old 12-05-2001
A terminal hangup signal is a SIGHUP. See the trap man page for info on catching and handling signals in Bourne and Korn shell. See onintr for C shell.
# 7  
Old 12-06-2001
Re: read

Quote:
if (test $? -ne 0)
What that's doing (I think), is evaluating if the "test " command was successful, which it will be any time your read statement succeeds.

And actually, I don't think you need the test command in there at all...
if [ "$?" -ne "0" ]; then


Or also, assuming you're using a fairly modern sh, you could even save a line of code and try:

read resp || exit 1

It'll simply exit (with status -ne 0) if the read statement fails. (BTW, those are two pipe symbols, no space inbetween)
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Invoking Application in Shell Script

Hi All, I have a scenario : 1. A list of servers naming server21, server 22, server 23 etc. This list of servers is separate for my environments. Env1 has 3 server Env2 has 5 serves Env3 has 10 servers 2. Each server accesses application through which I want to invoke some method. So... (7 Replies)
Discussion started by: ankur328
7 Replies

2. Shell Programming and Scripting

Problem invoking shell script

whats wrong here?! ________________ #!/bin/sh # FILE: clean_dirs # GOAL : To clean up directories used in Oracle processing # LANGUAGE : shell script (sh) # PARAMETERS : Input_File # 11/07/02 acri - modified to cd into the directory so it will... (7 Replies)
Discussion started by: gillraj
7 Replies

3. Shell Programming and Scripting

Invoking one shell script from another unix box

Hello All, I have a shell script A which is in one unix box. Also i have a script B in another unix box. Now i'm struggling to find a way to invoke A shell script from B shell script. Is it possible to do this in any way..Request you anybody please help me in this point. Thanks in advance. (6 Replies)
Discussion started by: RSC1985
6 Replies

4. UNIX for Advanced & Expert Users

Invoking shell script with perl command.

Hi All, I am using the following command to invoke the shell script from a perl command. perl -i.bak -pe'BEGIN { $cmd = "/opt/coreservices/tomcat-5.5.9/bin/digest.sh -a sha"; } s/(password=")(*)/ $1.`$cmd $2|cut -d: -f2|tr -d "\n"` /e ' $CATALINA_HOME/conf/tomcat-users.xml I need... (1 Reply)
Discussion started by: nua7
1 Replies

5. Shell Programming and Scripting

invoking a shell script inside cgi shell script

Hi, I have an HTML form through which I get some text as input. i need to run a shell script say script.sh inside a perl-cgi script named main_cgi.sh on the form input. I want to write the contents of the form in a file and then perform some command line operations like grep, cat on the text... (2 Replies)
Discussion started by: smriti_shridhar
2 Replies

6. Shell Programming and Scripting

returning to the parent shell after invoking a script within a script

Hi everybody, I have a script in which I'm invoking another script which runs in a subshell. after the script is executed I want to return to the parent shell as some variables are set. However i'm unable to return to my original shell as the script which i'm calling inside is invoked in... (5 Replies)
Discussion started by: gurukottur
5 Replies

7. Shell Programming and Scripting

Invoking Shell Script via php

list me commands to invoke a shell script from php once the submit button is clicked in the php page. Requirement is Once a submit button is clicked it should run a script that displays the outcome of the script in a html/php. Please help. Thanks in Advance, BubeshJ (2 Replies)
Discussion started by: bubeshj
2 Replies

8. Shell Programming and Scripting

Invoking shell script from html/jsp page

I want to invoke shell script named bubesh.sh when submit button clicked on html/jsp page.I am using an apache server and the html & shell script are in the same working directory.Please help. (2 Replies)
Discussion started by: bubeshj
2 Replies

9. Shell Programming and Scripting

invoking one shell script from other

hi, i am one day old in shell scritpting. how to invoke one shell script from the other? For eg.i have two shell scripts A.sh and B.sh. Inside A.sh i need to invoke B.sh and the return code of A.sh should be the value returned by B.sh. it would be better if you provide any sample shell... (3 Replies)
Discussion started by: ajay xavier
3 Replies

10. Shell Programming and Scripting

Wrong Shell Invoking My Script On Linux

I have a shell script that does NOT have the '#!' line at the top. It is written for ksh. The shell in my passwd entry is '/usr/bin/ksh' and my SHELL env variable is '/usr/bin/ksh'. Now, here's the issue. I invoke the script on Solaris with './myprog'. This works fine. I also run the same... (3 Replies)
Discussion started by: kowrip
3 Replies
Login or Register to Ask a Question